Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50158)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50159)
@@ -9197,14 +9236,14 @@
     mov word [bp+020h], ax                    ; 89 46 20
     mov word [bp+014h], dx                    ; 89 56 14
-    jmp short 06729h                          ; eb 2a
-    mov bx, 00da6h                            ; bb a6 0d
+    jmp short 06748h                          ; eb 2a
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 c2 b1
+    call 018e1h                               ; e8 b8 b1
     push word [bp+014h]                       ; ff 76 14
     push word [bp+020h]                       ; ff 76 20
     push 008bch                               ; 68 bc 08
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 f5 b1
+    call 01922h                               ; e8 eb b1
     add sp, strict byte 00008h                ; 83 c4 08
     or byte [bp+028h], 001h                   ; 80 4e 28 01
@@ -9217,5 +9256,143 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-init_rtc_:                                   ; 0xf672f LB 0x28
+_inv_op_handler:                             ; 0xf674e LB 0x195
+    push bp                                   ; 55
+    mov bp, sp                                ; 89 e5
+    push si                                   ; 56
+    push di                                   ; 57
+    push ax                                   ; 50
+    push ax                                   ; 50
+    les bx, [bp+018h]                         ; c4 5e 18
+    cmp byte [es:bx], 0f0h                    ; 26 80 3f f0
+    jne short 06764h                          ; 75 06
+    inc word [bp+018h]                        ; ff 46 18
+    jmp near 068dch                           ; e9 78 01
+    cmp word [es:bx], 0050fh                  ; 26 81 3f 0f 05
+    jne near 068d8h                           ; 0f 85 6b 01
+    mov si, 00800h                            ; be 00 08
+    xor ax, ax                                ; 31 c0
+    mov word [bp-006h], ax                    ; 89 46 fa
+    mov word [bp-008h], ax                    ; 89 46 f8
+    mov es, ax                                ; 8e c0
+    mov bx, word [es:si+02ch]                 ; 26 8b 5c 2c
+    sub bx, strict byte 00006h                ; 83 eb 06
+    mov dx, word [es:si+020h]                 ; 26 8b 54 20
+    mov ax, word [es:si+01ah]                 ; 26 8b 44 1a
+    mov es, dx                                ; 8e c2
+    mov word [es:bx], ax                      ; 26 89 07
+    mov es, [bp-006h]                         ; 8e 46 fa
+    mov ax, word [es:si+022h]                 ; 26 8b 44 22
+    mov es, dx                                ; 8e c2
+    mov word [es:bx+002h], ax                 ; 26 89 47 02
+    mov es, [bp-006h]                         ; 8e 46 fa
+    mov ax, word [es:si+018h]                 ; 26 8b 44 18
+    mov es, dx                                ; 8e c2
+    mov word [es:bx+004h], ax                 ; 26 89 47 04
+    mov es, [bp-006h]                         ; 8e 46 fa
+    movzx bx, byte [es:si+038h]               ; 26 0f b6 5c 38
+    mov di, word [es:si+036h]                 ; 26 8b 7c 36
+    mov ax, word [es:si+024h]                 ; 26 8b 44 24
+    xor dx, dx                                ; 31 d2
+    mov cx, strict word 00004h                ; b9 04 00
+    sal ax, 1                                 ; d1 e0
+    rcl dx, 1                                 ; d1 d2
+    loop 067bdh                               ; e2 fa
+    cmp bx, dx                                ; 39 d3
+    jne short 067cbh                          ; 75 04
+    cmp di, ax                                ; 39 c7
+    je short 067d0h                           ; 74 05
+    mov word [bp-008h], strict word 00001h    ; c7 46 f8 01 00
+    mov es, [bp-006h]                         ; 8e 46 fa
+    movzx di, byte [es:si+04ah]               ; 26 0f b6 7c 4a
+    mov bx, word [es:si+048h]                 ; 26 8b 5c 48
+    mov ax, word [es:si+01eh]                 ; 26 8b 44 1e
+    xor dx, dx                                ; 31 d2
+    mov cx, strict word 00004h                ; b9 04 00
+    sal ax, 1                                 ; d1 e0
+    rcl dx, 1                                 ; d1 d2
+    loop 067e5h                               ; e2 fa
+    cmp di, dx                                ; 39 d7
+    jne short 067f3h                          ; 75 04
+    cmp bx, ax                                ; 39 c3
+    je short 067f7h                           ; 74 04
+    or byte [bp-008h], 002h                   ; 80 4e f8 02
+    push strict byte 00000h                   ; 6a 00
+    push 00800h                               ; 68 00 08
+    push strict byte 0001fh                   ; 6a 1f
+    db  08bh, 0dch
+    ; mov bx, sp                                ; 8b dc
+    lgdt [ss:bx]                              ; 36 0f 01 17
+    add sp, strict byte 00006h                ; 83 c4 06
+    mov es, [bp-006h]                         ; 8e 46 fa
+    mov ax, word [es:si+03ah]                 ; 26 8b 44 3a
+    mov word [es:si+008h], ax                 ; 26 89 44 08
+    mov ax, word [es:si+036h]                 ; 26 8b 44 36
+    mov word [es:si+00ah], ax                 ; 26 89 44 0a
+    movzx dx, byte [es:si+039h]               ; 26 0f b6 54 39
+    sal dx, 008h                              ; c1 e2 08
+    movzx ax, byte [es:si+038h]               ; 26 0f b6 44 38
+    or dx, ax                                 ; 09 c2
+    mov word [es:si+00ch], dx                 ; 26 89 54 0c
+    mov word [es:si+00eh], strict word 00000h ; 26 c7 44 0e 00 00
+    mov ax, word [es:si+04ch]                 ; 26 8b 44 4c
+    mov word [es:si], ax                      ; 26 89 04
+    mov ax, word [es:si+048h]                 ; 26 8b 44 48
+    mov word [es:si+002h], ax                 ; 26 89 44 02
+    movzx dx, byte [es:si+04bh]               ; 26 0f b6 54 4b
+    sal dx, 008h                              ; c1 e2 08
+    movzx ax, byte [es:si+04ah]               ; 26 0f b6 44 4a
+    or dx, ax                                 ; 09 c2
+    mov word [es:si+004h], dx                 ; 26 89 54 04
+    movzx ax, byte [es:si+05ch]               ; 26 0f b6 44 5c
+    mov dx, word [es:si+05ah]                 ; 26 8b 54 5a
+    push ax                                   ; 50
+    push dx                                   ; 52
+    push word [es:si+05eh]                    ; 26 ff 74 5e
+    db  08bh, 0dch
+    ; mov bx, sp                                ; 8b dc
+    lidt [ss:bx]                              ; 36 0f 01 1f
+    add sp, strict byte 00006h                ; 83 c4 06
+    mov cx, word [bp-008h]                    ; 8b 4e f8
+    mov ax, 00080h                            ; b8 80 00
+    mov ss, ax                                ; 8e d0
+    mov ax, word [ss:0001eh]                  ; 36 a1 1e 00
+    mov ds, ax                                ; 8e d8
+    mov ax, word [ss:00024h]                  ; 36 a1 24 00
+    mov es, ax                                ; 8e c0
+    smsw ax                                   ; 0f 01 e0
+    inc ax                                    ; 40
+    lmsw ax                                   ; 0f 01 f0
+    mov ax, strict word 00008h                ; b8 08 00
+    test cx, strict word 00001h               ; f7 c1 01 00
+    je near 06895h                            ; 0f 84 02 00
+    mov es, ax                                ; 8e c0
+    test cx, strict word 00002h               ; f7 c1 02 00
+    je near 068bdh                            ; 0f 84 20 00
+    mov bx, word [word ss:00000h]             ; 36 8b 1e 00 00
+    mov word [word ss:00008h], bx             ; 36 89 1e 08 00
+    mov bx, word [word ss:00002h]             ; 36 8b 1e 02 00
+    mov word [word ss:0000ah], bx             ; 36 89 1e 0a 00
+    mov bx, word [word ss:00004h]             ; 36 8b 1e 04 00
+    mov word [word ss:0000ch], bx             ; 36 89 1e 0c 00
+    mov ds, ax                                ; 8e d8
+    mov eax, cr0                              ; 0f 20 c0
+    dec ax                                    ; 48
+    mov cr0, eax                              ; 0f 22 c0
+    mov sp, strict word 00026h                ; bc 26 00
+    popaw                                     ; 61
+    mov sp, word [word ss:0002ch]             ; 36 8b 26 2c 00
+    sub sp, strict byte 00006h                ; 83 ec 06
+    mov ss, [word ss:00020h]                  ; 36 8e 16 20 00
+    iret                                      ; cf
+    jmp short 068dch                          ; eb 04
+    sti                                       ; fb
+    hlt                                       ; f4
+    jmp short 068d9h                          ; eb fd
+    lea sp, [bp-004h]                         ; 8d 66 fc
+    pop di                                    ; 5f
+    pop si                                    ; 5e
+    pop bp                                    ; 5d
+    retn                                      ; c3
+init_rtc_:                                   ; 0xf68e3 LB 0x28
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -9223,17 +9400,17 @@
     mov dx, strict word 00026h                ; ba 26 00
     mov ax, strict word 0000ah                ; b8 0a 00
-    call 01670h                               ; e8 34 af
+    call 01679h                               ; e8 89 ad
     mov dx, strict word 00002h                ; ba 02 00
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 01670h                               ; e8 2b af
+    call 01679h                               ; e8 80 ad
     mov ax, strict word 0000ch                ; b8 0c 00
-    call 0165ch                               ; e8 11 af
+    call 0165ch                               ; e8 5d ad
     mov ax, strict word 0000dh                ; b8 0d 00
-    call 0165ch                               ; e8 0b af
+    call 0165ch                               ; e8 57 ad
     lea sp, [bp-002h]                         ; 8d 66 fe
     pop dx                                    ; 5a
     pop bp                                    ; 5d
     retn                                      ; c3
-rtc_updating_:                               ; 0xf6757 LB 0x21
+rtc_updating_:                               ; 0xf690b LB 0x21
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -9241,11 +9418,11 @@
     mov dx, 061a8h                            ; ba a8 61
     dec dx                                    ; 4a
-    je short 0676fh                           ; 74 0e
+    je short 06923h                           ; 74 0e
     mov ax, strict word 0000ah                ; b8 0a 00
-    call 0165ch                               ; e8 f5 ae
+    call 0165ch                               ; e8 41 ad
     test AL, strict byte 080h                 ; a8 80
-    jne short 0675eh                          ; 75 f3
+    jne short 06912h                          ; 75 f3
     xor ax, ax                                ; 31 c0
-    jmp short 06772h                          ; eb 03
+    jmp short 06926h                          ; eb 03
     mov ax, strict word 00001h                ; b8 01 00
     lea sp, [bp-002h]                         ; 8d 66 fe
@@ -9253,5 +9430,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-_int70_function:                             ; 0xf6778 LB 0xbe
+_int70_function:                             ; 0xf692c LB 0xbe
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -9259,57 +9436,57 @@
     push ax                                   ; 50
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 0165ch                               ; e8 d9 ae
+    call 0165ch                               ; e8 25 ad
     mov dl, al                                ; 88 c2
     mov byte [bp-004h], al                    ; 88 46 fc
     mov ax, strict word 0000ch                ; b8 0c 00
-    call 0165ch                               ; e8 ce ae
+    call 0165ch                               ; e8 1a ad
     mov dh, al                                ; 88 c6
     test dl, 060h                             ; f6 c2 60
-    je near 0681dh                            ; 0f 84 86 00
+    je near 069d1h                            ; 0f 84 86 00
     test AL, strict byte 020h                 ; a8 20
-    je short 0679fh                           ; 74 04
+    je short 06953h                           ; 74 04
     sti                                       ; fb
     int 04ah                                  ; cd 4a
     cli                                       ; fa
     test dh, 040h                             ; f6 c6 40
-    je near 0681dh                            ; 0f 84 77 00
+    je near 069d1h                            ; 0f 84 77 00
     mov dx, 000a0h                            ; ba a0 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 51 ae
+    call 01600h                               ; e8 9d ac
     test al, al                               ; 84 c0
-    je short 0681dh                           ; 74 6a
+    je short 069d1h                           ; 74 6a
     mov dx, 0009ch                            ; ba 9c 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01638h                               ; e8 7c ae
+    call 01638h                               ; e8 c8 ac
     test dx, dx                               ; 85 d2
-    jne short 06809h                          ; 75 49
+    jne short 069bdh                          ; 75 49
     cmp ax, 003d1h                            ; 3d d1 03
-    jnc short 06809h                          ; 73 44
+    jnc short 069bdh                          ; 73 44
     mov dx, 00098h                            ; ba 98 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 4e ae
+    call 0161ch                               ; e8 9a ac
     mov si, ax                                ; 89 c6
     mov dx, 0009ah                            ; ba 9a 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 43 ae
+    call 0161ch                               ; e8 8f ac
     mov cx, ax                                ; 89 c1
     xor bx, bx                                ; 31 db
     mov dx, 000a0h                            ; ba a0 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 28 ae
+    call 0160eh                               ; e8 74 ac
     mov al, byte [bp-004h]                    ; 8a 46 fc
     and AL, strict byte 037h                  ; 24 37
     movzx dx, al                              ; 0f b6 d0
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 01670h                               ; e8 7c ae
+    call 01679h                               ; e8 d1 ac
     mov dx, cx                                ; 89 ca
     mov ax, si                                ; 89 f0
-    call 01600h                               ; e8 05 ae
+    call 01600h                               ; e8 51 ac
     or AL, strict byte 080h                   ; 0c 80
     movzx bx, al                              ; 0f b6 d8
     mov dx, cx                                ; 89 ca
     mov ax, si                                ; 89 f0
-    call 0160eh                               ; e8 07 ae
-    jmp short 0681dh                          ; eb 14
+    call 0160eh                               ; e8 53 ac
+    jmp short 069d1h                          ; eb 14
     mov bx, ax                                ; 89 c3
     add bx, 0fc2fh                            ; 81 c3 2f fc
@@ -9318,22 +9495,18 @@
     mov dx, 0009ch                            ; ba 9c 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0164ah                               ; e8 2d ae
-    call 0e03bh                               ; e8 1b 78
+    call 0164ah                               ; e8 79 ac
+    call 0e03bh                               ; e8 67 76
     lea sp, [bp-002h]                         ; 8d 66 fe
     pop si                                    ; 5e
     pop bp                                    ; 5d
     retn                                      ; c3
-    dec bp                                    ; 4d
-    push 06876h                               ; 68 76 68
-    wait                                      ; 9b
-    push 068cdh                               ; 68 cd 68
-    sbb AL, strict byte 069h                  ; 1c 69
-    push sp                                   ; 54
-    db  069h
-    xchg di, ax                               ; 97
-    db  069h
-    out DX, AL                                ; ee
-    db  069h
-_int1a_function:                             ; 0xf6836 LB 0x1c8
+    add word [bp+si+02ah], bp                 ; 01 6a 2a
+    push strict byte 0004fh                   ; 6a 4f
+    push strict byte 0ff81h                   ; 6a 81
+    push strict byte 0ffd0h                   ; 6a d0
+    push strict byte 00008h                   ; 6a 08
+    imul cx, word [bp+di+06bh], strict byte 0ffa2h ; 6b 4b 6b a2
+    db  06bh
+_int1a_function:                             ; 0xf69ea LB 0x1c8
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -9341,8 +9514,8 @@
     mov al, byte [bp+013h]                    ; 8a 46 13
     cmp AL, strict byte 007h                  ; 3c 07
-    jnbe near 06872h                          ; 0f 87 2f 00
+    jnbe near 06a26h                          ; 0f 87 2f 00
     movzx bx, al                              ; 0f b6 d8
     add bx, bx                                ; 01 db
-    jmp word [cs:bx+06826h]                   ; 2e ff a7 26 68
+    jmp word [cs:bx+069dah]                   ; 2e ff a7 da 69
     cli                                       ; fa
     mov bx, 0046eh                            ; bb 6e 04
@@ -9375,39 +9548,39 @@
     sti                                       ; fb
     mov byte [bp+013h], 000h                  ; c6 46 13 00
-    jmp short 06872h                          ; eb d7
-    call 06757h                               ; e8 b9 fe
+    jmp short 06a26h                          ; eb d7
+    call 0690bh                               ; e8 b9 fe
     test ax, ax                               ; 85 c0
-    je short 068a4h                           ; 74 02
-    jmp short 06872h                          ; eb ce
+    je short 06a58h                           ; 74 02
+    jmp short 06a26h                          ; eb ce
     xor ax, ax                                ; 31 c0
-    call 0165ch                               ; e8 b3 ad
+    call 0165ch                               ; e8 ff ab
     mov byte [bp+00fh], al                    ; 88 46 0f
     mov ax, strict word 00002h                ; b8 02 00
-    call 0165ch                               ; e8 aa ad
+    call 0165ch                               ; e8 f6 ab
     mov byte [bp+010h], al                    ; 88 46 10
     mov ax, strict word 00004h                ; b8 04 00
-    call 0165ch                               ; e8 a1 ad
+    call 0165ch                               ; e8 ed ab
     mov bl, al                                ; 88 c3
     mov byte [bp+011h], al                    ; 88 46 11
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 0165ch                               ; e8 96 ad
+    call 0165ch                               ; e8 e2 ab
     and AL, strict byte 001h                  ; 24 01
     mov byte [bp+00eh], al                    ; 88 46 0e
-    jmp short 06912h                          ; eb 45
-    call 06757h                               ; e8 87 fe
+    jmp short 06ac6h                          ; eb 45
+    call 0690bh                               ; e8 87 fe
     test ax, ax                               ; 85 c0
-    je short 068d7h                           ; 74 03
-    call 0672fh                               ; e8 58 fe
+    je short 06a8bh                           ; 74 03
+    call 068e3h                               ; e8 58 fe
     movzx dx, byte [bp+00fh]                  ; 0f b6 56 0f
     xor ax, ax                                ; 31 c0
-    call 01670h                               ; e8 90 ad
+    call 01679h                               ; e8 e5 ab
     movzx dx, byte [bp+010h]                  ; 0f b6 56 10
     mov ax, strict word 00002h                ; b8 02 00
-    call 01670h                               ; e8 86 ad
+    call 01679h                               ; e8 db ab
     movzx dx, byte [bp+011h]                  ; 0f b6 56 11
     mov ax, strict word 00004h                ; b8 04 00
-    call 01670h                               ; e8 7c ad
+    call 01679h                               ; e8 d1 ab
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 0165ch                               ; e8 62 ad
+    call 0165ch                               ; e8 ae ab
     mov bl, al                                ; 88 c3
     and bl, 060h                              ; 80 e3 60
@@ -9418,69 +9591,69 @@
     movzx dx, bl                              ; 0f b6 d3
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 01670h                               ; e8 5e ad
+    call 01679h                               ; e8 b3 ab
     mov byte [bp+013h], 000h                  ; c6 46 13 00
     mov byte [bp+012h], bl                    ; 88 5e 12
-    jmp near 06872h                           ; e9 56 ff
+    jmp near 06a26h                           ; e9 56 ff
     mov byte [bp+013h], 000h                  ; c6 46 13 00
-    call 06757h                               ; e8 34 fe
+    call 0690bh                               ; e8 34 fe
     test ax, ax                               ; 85 c0
-    je short 0692ah                           ; 74 03
-    jmp near 06872h                           ; e9 48 ff
+    je short 06adeh                           ; 74 03
+    jmp near 06a26h                           ; e9 48 ff
     mov ax, strict word 00009h                ; b8 09 00
-    call 0165ch                               ; e8 2c ad
+    call 0165ch                               ; e8 78 ab
     mov byte [bp+010h], al                    ; 88 46 10
     mov ax, strict word 00008h                ; b8 08 00
-    call 0165ch                               ; e8 23 ad
+    call 0165ch                               ; e8 6f ab
     mov byte [bp+00fh], al                    ; 88 46 0f
     mov ax, strict word 00007h                ; b8 07 00
-    call 0165ch                               ; e8 1a ad
+    call 0165ch                               ; e8 66 ab
     mov byte [bp+00eh], al                    ; 88 46 0e
     mov ax, strict word 00032h                ; b8 32 00
-    call 0165ch                               ; e8 11 ad
+    call 0165ch                               ; e8 5d ab
     mov byte [bp+011h], al                    ; 88 46 11
     mov byte [bp+012h], al                    ; 88 46 12
-    jmp near 06872h                           ; e9 1e ff
-    call 06757h                               ; e8 00 fe
+    jmp near 06a26h                           ; e9 1e ff
+    call 0690bh                               ; e8 00 fe
     test ax, ax                               ; 85 c0
-    je short 06961h                           ; 74 06
-    call 0672fh                               ; e8 d1 fd
-    jmp near 06872h                           ; e9 11 ff
+    je short 06b15h                           ; 74 06
+    call 068e3h                               ; e8 d1 fd
+    jmp near 06a26h                           ; e9 11 ff
     movzx dx, byte [bp+010h]                  ; 0f b6 56 10
     mov ax, strict word 00009h                ; b8 09 00
-    call 01670h                               ; e8 05 ad
+    call 01679h                               ; e8 5a ab
     movzx dx, byte [bp+00fh]                  ; 0f b6 56 0f
     mov ax, strict word 00008h                ; b8 08 00
-    call 01670h                               ; e8 fb ac
+    call 01679h                               ; e8 50 ab
     movzx dx, byte [bp+00eh]                  ; 0f b6 56 0e
     mov ax, strict word 00007h                ; b8 07 00
-    call 01670h                               ; e8 f1 ac
+    call 01679h                               ; e8 46 ab
     movzx dx, byte [bp+011h]                  ; 0f b6 56 11
     mov ax, strict word 00032h                ; b8 32 00
-    call 01670h                               ; e8 e7 ac
+    call 01679h                               ; e8 3c ab
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 0165ch                               ; e8 cd ac
+    call 0165ch                               ; e8 19 ab
     mov bl, al                                ; 88 c3
     and bl, 07fh                              ; 80 e3 7f
-    jmp near 06909h                           ; e9 72 ff
+    jmp near 06abdh                           ; e9 72 ff
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 0165ch                               ; e8 bf ac
+    call 0165ch                               ; e8 0b ab
     mov bl, al                                ; 88 c3
     mov word [bp+012h], strict word 00000h    ; c7 46 12 00 00
     test AL, strict byte 020h                 ; a8 20
-    je short 069abh                           ; 74 03
-    jmp near 06872h                           ; e9 c7 fe
-    call 06757h                               ; e8 a9 fd
+    je short 06b5fh                           ; 74 03
+    jmp near 06a26h                           ; e9 c7 fe
+    call 0690bh                               ; e8 a9 fd
     test ax, ax                               ; 85 c0
-    je short 069b5h                           ; 74 03
-    call 0672fh                               ; e8 7a fd
+    je short 06b69h                           ; 74 03
+    call 068e3h                               ; e8 7a fd
     movzx dx, byte [bp+00fh]                  ; 0f b6 56 0f
     mov ax, strict word 00001h                ; b8 01 00
-    call 01670h                               ; e8 b1 ac
+    call 01679h                               ; e8 06 ab
     movzx dx, byte [bp+010h]                  ; 0f b6 56 10
     mov ax, strict word 00003h                ; b8 03 00
-    call 01670h                               ; e8 a7 ac
+    call 01679h                               ; e8 fc aa
     movzx dx, byte [bp+011h]                  ; 0f b6 56 11
     mov ax, strict word 00005h                ; b8 05 00
-    call 01670h                               ; e8 9d ac
+    call 01679h                               ; e8 f2 aa
     mov dx, 000a1h                            ; ba a1 00
     in AL, DX                                 ; ec
@@ -9494,13 +9667,13 @@
     movzx dx, al                              ; 0f b6 d0
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 01670h                               ; e8 85 ac
-    jmp near 06872h                           ; e9 84 fe
+    call 01679h                               ; e8 da aa
+    jmp near 06a26h                           ; e9 84 fe
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 0165ch                               ; e8 68 ac
+    call 0165ch                               ; e8 b4 aa
     mov bl, al                                ; 88 c3
     and AL, strict byte 057h                  ; 24 57
     movzx dx, al                              ; 0f b6 d0
-    jmp near 0690ch                           ; e9 0e ff
-send_to_mouse_ctrl_:                         ; 0xf69fe LB 0x34
+    jmp near 06ac0h                           ; e9 0e ff
+send_to_mouse_ctrl_:                         ; 0xf6bb2 LB 0x34
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -9513,9 +9686,9 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 002h                 ; a8 02
-    je short 06a1dh                           ; 74 0e
+    je short 06bd1h                           ; 74 0e
     push 008f6h                               ; 68 f6 08
-    push 0116eh                               ; 68 6e 11
+    push 0116ah                               ; 68 6a 11
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 f3 ae
+    call 01922h                               ; e8 54 ad
     add sp, strict byte 00006h                ; 83 c4 06
     mov AL, strict byte 0d4h                  ; b0 d4
@@ -9531,5 +9704,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-get_mouse_data_:                             ; 0xf6a32 LB 0x3b
+get_mouse_data_:                             ; 0xf6be6 LB 0x3b
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -9545,13 +9718,13 @@
     and ax, strict word 00021h                ; 25 21 00
     cmp ax, strict word 00021h                ; 3d 21 00
-    je short 06a53h                           ; 74 07
+    je short 06c07h                           ; 74 07
     test cx, cx                               ; 85 c9
-    je short 06a53h                           ; 74 03
+    je short 06c07h                           ; 74 03
     dec cx                                    ; 49
-    jmp short 06a3eh                          ; eb eb
+    jmp short 06bf2h                          ; eb eb
     test cx, cx                               ; 85 c9
-    jne short 06a5bh                          ; 75 04
+    jne short 06c0fh                          ; 75 04
     mov AL, strict byte 001h                  ; b0 01
-    jmp short 06a66h                          ; eb 0b
+    jmp short 06c1ah                          ; eb 0b
     mov dx, strict word 00060h                ; ba 60 00
     in AL, DX                                 ; ec
@@ -9565,5 +9738,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-set_kbd_command_byte_:                       ; 0xf6a6d LB 0x32
+set_kbd_command_byte_:                       ; 0xf6c21 LB 0x32
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -9576,9 +9749,9 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 002h                 ; a8 02
-    je short 06a8ch                           ; 74 0e
+    je short 06c40h                           ; 74 0e
     push 00900h                               ; 68 00 09
-    push 0116eh                               ; 68 6e 11
+    push 0116ah                               ; 68 6a 11
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 84 ae
+    call 01922h                               ; e8 e5 ac
     add sp, strict byte 00006h                ; 83 c4 06
     mov AL, strict byte 060h                  ; b0 60
